from __future__ import division

import log
import eca

from sklearn import linear_model
import numpy as np
import simplejson as json

import random
import argparse
import os

logger = log.setup_logger()

parser = argparse.ArgumentParser(description = 'Japanese vowel classification. ')
parser.add_argument('--dataset', default='float', choices=['float', 'bits'])

args = parser.parse_args()
if args.dataset == 'float':
    file = 'floatvalues.json'
else:
    file = 'bitvalues.json'

if args.dataset == 'float':
    logger.info('Running japanese vowel classification without transforming the input')
else:
    logger.info('Running japanese vowel classification on the original data converted to bits')

regNode = linear_model.LogisticRegression(intercept_scaling=5, max_iter=10000, solver="sag")

with open(os.path.join(os.path.dirname(__file__), "vowels", file)) as f:
    data = json.loads(f.read())

training_data = []
training_class = []
map(training_data.extend, data["train"])
for i in xrange(len(data["train"])):
    for _ in xrange(len(data["train"][i])):
        training_class.append(i)

training_data = np.array(training_data)
training_class = np.array(training_class)
regNode.fit(training_data, training_class)

correct = 0
n_tests = 0
for person, tests in enumerate(data["test"]):
    for test in tests:
        n_tests += 1
        result = regNode.predict(np.array([test])).tolist()[0]

        if result == person:
            correct += 1

logger.info("Test completed, %f%% correct outputs (%d/%d)" % ((correct / n_tests) * 100, correct, n_tests))
